diff --git a/lib/foreman/default_data/loader.rb b/lib/foreman/default_data/loader.rb
new file mode 100644
index 0000000..8aa05fa
--- /dev/null
+++ b/lib/foreman/default_data/loader.rb
@@ -0,0 +1,156 @@
+# redMine - project management software
+# Copyright (C) 2006-2007  Jean-Philippe Lang
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version
+# 
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE  See the
+# GNU General Public License for more details
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
+
+module Foreman
+  module DefaultData
+    class DataAlreadyLoaded < Exception; end
+
+    module Loader
+      class << self
+        # Returns true if no data is already loaded in the database
+        # otherwise false
+        def no_data?
+          !Role.find(:first, :conditions => {:builtin => 0})
+        end
+        
+        # Loads the default data
+        # Raises a RecordNotSaved exception if something goes wrong
+        def load(reset=false)
+
+          # We may be executing something like rake db:migrate:reset, which destroys this table; only continue if the table exists
+          Role.count rescue return
+          Role.transaction do
+            # Roles
+            manager = Role.name_is("Manager").empty? ? Role.create(:name => "Manager") : Role.name_is("Manager")[0]
+            if reset or manager.permissions.empty?
+              manager.update_attribute :permissions, manager.setable_permissions.collect {|p| p.name}
+            end
+
+            ptable_editor =  Role.name_is("Edit partition tables").empty? ? Role.create(:name => "Edit partition tables") : Role.name_is("Edit partition tables")[0]
+            if reset or ptable_editor.permissions.empty?
+              ptable_editor.update_attribute :permissions, [:view_ptables,
+                                                           :create_ptables,
+                                                           :edit_ptables,
+                                                           :destroy_ptables]
+            end
+
+            hosts_reader =  Role.name_is("View hosts").empty? ? Role.create(:name => "View hosts") : Role.name_is("View hosts")[0]
+            if reset or hosts_reader.permissions.empty?
+              hosts_reader.update_attribute :permissions, [:view_hosts]
+            end
+
+            hosts_editor =  Role.name_is("Edit hosts").empty? ? Role.create(:name => "Edit hosts") : Role.name_is("Edit hosts")[0]
+            if reset or hosts_editor.permissions.empty?
+              hosts_editor.update_attribute :permissions, [:view_hosts,    :edit_hosts,    :create_hosts,    :destroy_hosts]
+            end
+
+            viewer =  Role.name_is("Viewer").empty? ? Role.create(:name => "Viewer") : Role.name_is("Viewer")[0]
+            if reset or viewer.permissions.empty?
+              viewer.update_attribute :permissions, [:view_hosts,
+                                                     :view_puppetclasses,
+                                                     :view_hostgroups,
+                                                     :view_domains,
+                                                     :view_operatingsystems,
+                                                     :view_medias,
+                                                     :view_models,
+                                                     :view_environments,
+                                                     :view_architectures,
+                                                     :view_ptables,
+                                                     :view_globals,
+                                                     :view_external_variables,
+                                                     :view_authenticators,
+                                                     :access_settings,
+                                                     :access_dashboard,
+                                                     :view_reports,
+                                                     :view_facts,
+                                                     :view_statistics,
+                                                     :view_usergroups,
+                                                     :view_users,
+                                                     :view_audit_logs]
+            end
+
+            siteman = Role.name_is("Site manager").empty? ? Role.create(:name => "Site manager") : Role.name_is("Site manager")[0]
+            if reset or siteman.permissions.empty?
+              siteman.update_attribute :permissions, [ :view_architectures,
+                                                       :view_audit_logs,
+                                                       :view_authenticators,
+                                                       :access_dashboard,
+                                                       :view_domains,
+                                                       :view_environments,
+                                                       :import_environments,
+                                                       :view_external_variables,
+                                                       :create_external_variables,
+                                                       :edit_external_variables,
+                                                       :destroy_external_variables,
+                                                       :view_facts,
+                                                       :view_globals,
+                                                       :view_hostgroups,
+                                                       :view_hosts,
+                                                       :view_hosts,
+                                                       :create_hosts,
+                                                       :edit_hosts,
+                                                       :destroy_hosts,
+                                                       :view_medias,
+                                                       :create_medias,
+                                                       :edit_medias,
+                                                       :destroy_medias,
+                                                       :view_models,
+                                                       :view_operatingsystems,
+                                                       :view_ptables,
+                                                       :view_puppetclasses,
+                                                       :import_puppetclasses,
+                                                       :view_reports,
+                                                       :destroy_reports,
+                                                       :access_settings,
+                                                       :view_statistics,
+                                                       :view_usergroups,
+                                                       :create_usergroups,
+                                                       :edit_usergroups,
+                                                       :destroy_usergroups,
+                                                       :view_users,
+                                                       :edit_users]
+            end
+            if reset or Role.default_user.permissions.empty?
+              Role.default_user.update_attribute :permissions, [:view_hosts,
+                                                                :view_puppetclasses,
+                                                                :view_hostgroups,
+                                                                :view_domains,
+                                                                :view_operatingsystems,
+                                                                :view_medias,
+                                                                :view_models,
+                                                                :view_environments,
+                                                                :view_architectures,
+                                                                :view_ptables,
+                                                                :view_globals,
+                                                                :view_external_variables,
+                                                                :view_authenticators,
+                                                                :access_settings,
+                                                                :access_dashboard,
+                                                                :view_reports,
+                                                                :view_facts,
+                                                                :view_statistics]
+            end
+            if reset or Role.anonymous.permissions.empty?
+              Role.anonymous.update_attribute :permissions, [:view_hosts]
+            end
+          end
+          true
+        end
+      end
+    end
+  end
+end
diff --git a/lib/tabular_form_builder.rb b/lib/tabular_form_builder.rb
new file mode 100644
index 0000000..d0433fb
--- /dev/null
+++ b/lib/tabular_form_builder.rb
@@ -0,0 +1,50 @@
+# redMine - project management software
+# Copyright (C) 2006-2007  Jean-Philippe Lang
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+# 
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+require 'action_view/helpers/form_helper'
+
+class TabularFormBuilder < ActionView::Helpers::FormBuilder
+  
+  def initialize(object_name, object, template, options, proc)
+    super
+  end      
+      
+  (field_helpers - %w(radio_button hidden_field) + %w(date_select)).each do |selector|
+    src = <<-END_SRC
+    def #{selector}(field, options = {}) 
+      label_for_field(field, options) + super
+    end
+    END_SRC
+    class_eval src, __FILE__, __LINE__
+  end
+  
+  def select(field, choices, options = {}, html_options = {}) 
+    label_for_field(field, options) + super
+  end
+  
+  # Returns a label tag for the given field
+  def label_for_field(field, options = {})
+      return '' if options.delete(:no_label)
+      text = options[:label].is_a?(Symbol) ? l(options[:label]) : options[:label]
+      text ||= l(("field_" + field.to_s.gsub(/\_id$/, "")).to_sym)
+      text += @template.content_tag("span", " *", :class => "required") if options.delete(:required)
+      @template.content_tag("label", text, 
+                                     :style => "#{options[:style]}",
+                                     :class => (@object && @object.errors[field] ? "error" : nil), 
+                                     :for => (@object_name.to_s + "_" + field.to_s))
+  end
+end
diff --git a/lib/tasks/load_default_data.rake b/lib/tasks/load_default_data.rake
new file mode 100644
index 0000000..465348e
--- /dev/null
+++ b/lib/tasks/load_default_data.rake
@@ -0,0 +1,16 @@
+desc 'Load Foreman default configuration data.'
+
+namespace :foreman do
+  task :load_default_data => :environment do
+    
+    begin
+      Foreman::DefaultData::Loader.load(true)
+      puts "Default configuration data reloaded."
+    rescue Foreman::DefaultData::DataAlreadyLoaded => error
+      puts error
+    rescue => error
+      puts "Error: " + error
+      puts "Default configuration data was not loaded."
+    end
+  end
+end
diff --git a/public/javascripts/redmine-application.js b/public/javascripts/redmine-application.js
new file mode 100644
index 0000000..3313f6a
--- /dev/null
+++ b/public/javascripts/redmine-application.js
@@ -0,0 +1,132 @@
+/* redMine - project management software
+   Copyright (C) 2006-2008  Jean-Philippe Lang */
+
+function checkAll (id, checked) {
+	var els = Element.descendants(id);
+	for (var i = 0; i < els.length; i++) {
+    if (els[i].disabled==false) {
+      els[i].checked = checked;
+    }
+	}
+}
+
+function toggleCheckboxesBySelector(selector) {
+	boxes = $$(selector);
+	var all_checked = true;
+	for (i = 0; i < boxes.length; i++) { if (boxes[i].checked == false) { all_checked = false; } }
+	for (i = 0; i < boxes.length; i++) { boxes[i].checked = !all_checked; }
+}
+
+function showAndScrollTo(id, focus) {
+	Element.show(id);
+	if (focus!=null) { Form.Element.focus(focus); }
+	Element.scrollTo(id);
+}
+
+function toggleRowGroup(el) {
+	var tr = Element.up(el, 'tr');
+	var n = Element.next(tr);
+	tr.toggleClassName('open');
+	while (n != undefined && !n.hasClassName('group')) {
+		Element.toggle(n);
+		n = Element.next(n);
+	}
+}
+
+function toggleFieldset(el) {
+	var fieldset = Element.up(el, 'fieldset');
+	fieldset.toggleClassName('collapsed');
+	Effect.toggle(fieldset.down('div'), 'slide', {duration:0.2});
+}
+
+function showTab(name) {
+    var f = $$('div#content .tab-content');
+	for(var i=0; i<f.length; i++){
+		Element.hide(f[i]);
+	}
+    var f = $$('div.tabs a');
+	for(var i=0; i<f.length; i++){
+		Element.removeClassName(f[i], "selected");
+	}
+	Element.show('tab-content-' + name);
+	Element.addClassName('tab-' + name, "selected");
+	return false;
+}
+
+function moveTabRight(el) {
+	var lis = Element.up(el, 'div.tabs').down('ul').childElements();
+	var tabsWidth = 0;
+	var i;
+	for (i=0; i<lis.length; i++) {
+		if (lis[i].visible()) {
+			tabsWidth += lis[i].getWidth() + 6;
+		}
+	}
+	if (tabsWidth < Element.up(el, 'div.tabs').getWidth() - 60) {
+		return;
+	}
+	i=0;
+	while (i<lis.length && !lis[i].visible()) {
+		i++;
+	}
+	lis[i].hide();
+}
+
+function moveTabLeft(el) {
+	var lis = Element.up(el, 'div.tabs').down('ul').childElements();
+	var i = 0;
+	while (i<lis.length && !lis[i].visible()) {
+		i++;
+	}
+	if (i>0) {
+		lis[i-1].show();
+	}
+}
+
+function displayTabsButtons() {
+	var lis;
+	var tabsWidth = 0;
+	var i;
+	$$('div.tabs').each(function(el) {
+		lis = el.down('ul').childElements();
+		for (i=0; i<lis.length; i++) {
+			if (lis[i].visible()) {
+				tabsWidth += lis[i].getWidth() + 6;
+			}
+		}
+		if ((tabsWidth < el.getWidth() - 60) && (lis[0].visible())) {
+			el.down('div.tabs-buttons').hide();
+		} else {
+			el.down('div.tabs-buttons').show();
+		}
+	});
+}
+
+function promptToRemote(text, param, url) {
+    value = prompt(text + ':');
+    if (value) {
+        new Ajax.Request(url + '?' + param + '=' + encodeURIComponent(value), {asynchronous:true, evalScripts:true});
+        return false;
+    }
+}
+
+
+/* shows and hides ajax indicator */
+Ajax.Responders.register({
+    onCreate: function(){
+        if ($('ajax-indicator') && Ajax.activeRequestCount > 0) {
+            Element.show('ajax-indicator');
+        }
+    },
+    onComplete: function(){
+        if ($('ajax-indicator') && Ajax.activeRequestCount == 0) {
+            Element.hide('ajax-indicator');
+        }
+    }
+});
+
+Event.observe(window, 'load', function() {
+  $$('.hol').each(function(el) {
+  	el.hide();
+	});
+});
diff --git a/test/functional/architectures_controller_test.rb b/test/functional/architectures_controller_test.rb
index fbf5682..5c5211d 100644
--- a/test/functional/architectures_controller_test.rb
+++ b/test/functional/architectures_controller_test.rb
@@ -47,4 +47,21 @@ class ArchitecturesControllerTest < ActionController::TestCase
     assert_redirected_to architectures_url
     assert !Architecture.exists?(architecture.id)
   end
+
+  def setup_user
+     @request.session[:user] = users(:one).id
+     users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  def user_with_viewer_rights_should_fail_to_edit_an_architecture
+    setup_user
+    get :edit, {:id => Architecture.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  def user_with_viewer_rights_should_succeed_in_viewing_architectures
+    setup_user
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/audits_controller_test.rb b/test/functional/audits_controller_test.rb
index 4408a39..9254a8a 100644
--- a/test/functional/audits_controller_test.rb
+++ b/test/functional/audits_controller_test.rb
@@ -10,4 +10,20 @@ class AuditsControllerTest < ActionController::TestCase
     get :show, {:id => Audit.first}, set_session_user
     assert_template 'show'
   end
+
+  def setup_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+  def user_with_viewer_rights_should_fail_to edit_audit
+    setup_user
+    get :edit, {:id => Audit.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  def user_with_viewer_rights_succeed_in_viewing_audits
+    setup_user
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/auth_source_ldaps_controller_test.rb b/test/functional/auth_source_ldaps_controller_test.rb
index 2833558..f066263 100644
--- a/test/functional/auth_source_ldaps_controller_test.rb
+++ b/test/functional/auth_source_ldaps_controller_test.rb
@@ -46,4 +46,21 @@ class AuthSourceLdapsControllerTest < ActionController::TestCase
     assert_redirected_to auth_source_ldaps_url
     assert !AuthSourceLdap.exists?(auth_source_ldap.id)
   end
+
+   def setup_user
+     @request.session[:user] = users(:one).id
+     users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  def user_with_viewer_rights_should_fail_to_an_edit_authentication_source
+    setup_user
+    get :edit, {:id => AuthSourceLdap.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  def user_with_viewer_rights_should_succeed_in_viewing_authentication_sources
+    setup_user
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/common_parameters_controller_test.rb b/test/functional/common_parameters_controller_test.rb
index a3c9c89..d4ebd86 100644
--- a/test/functional/common_parameters_controller_test.rb
+++ b/test/functional/common_parameters_controller_test.rb
@@ -46,4 +46,24 @@ class CommonParametersControllerTest < ActionController::TestCase
     assert_redirected_to common_parameters_url
     assert !CommonParameter.exists?(common_parameter.id)
   end
+
+  def setup_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  context 'user with viewer rights' do
+
+    def user_with_viewer_rights_should_fail_to_edit_a_common_parameter
+      setup_user
+      get :edit, {:id => CommonParameter.first.id}
+      assert @response.status == '403 Forbidden'
+    end
+
+    def user_with_viewer_rights_should_succeed_in_viewing_common_parameters
+      setup_user
+      get :index
+      assert_response :success
+    end
+  end
 end
diff --git a/test/functional/dashboard_controller_test.rb b/test/functional/dashboard_controller_test.rb
index 2a7d689..00fb82a 100644
--- a/test/functional/dashboard_controller_test.rb
+++ b/test/functional/dashboard_controller_test.rb
@@ -6,4 +6,10 @@ class DashboardControllerTest < ActionController::TestCase
     assert_response :success
   end
 
+  def user_with_viewer_rights_should_succeed_in_viewing_the_dashboard
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/domains_controller_test.rb b/test/functional/domains_controller_test.rb
index 6373f33..5c187b4 100644
--- a/test/functional/domains_controller_test.rb
+++ b/test/functional/domains_controller_test.rb
@@ -47,4 +47,21 @@ class DomainsControllerTest < ActionController::TestCase
     assert_redirected_to domains_url
     assert !Domain.exists?(domain.id)
   end
+
+  def setup_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  def user_with_viewer_rights_should_fail_to_edit_a_domain
+    setup_users
+    get :edit, {:id => Domain.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  def user_with_viewer_rights_should_succeed_in_viewing_domains
+    setup_users
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/environments_controller_test.rb b/test/functional/environments_controller_test.rb
index 6bdf51d..f85ea39 100644
--- a/test/functional/environments_controller_test.rb
+++ b/test/functional/environments_controller_test.rb
@@ -156,4 +156,21 @@ class EnvironmentsControllerTest < ActionController::TestCase
 
     assert_redirected_to environments_url
   end
+
+  def setup_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  test 'user with viewer rights should fail to edit an environment' do
+    setup_user
+    get :edit, {:id => Environment.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should succeed in viewing environments' do
+    setup_user
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/fact_values_controller_test.rb b/test/functional/fact_values_controller_test.rb
index a1ba721..b8a7c6b 100644
--- a/test/functional/fact_values_controller_test.rb
+++ b/test/functional/fact_values_controller_test.rb
@@ -22,4 +22,10 @@ class FactValuesControllerTest < ActionController::TestCase
     assert_response :success
   end
 
+  test 'user with viewer rights should succeed in viewing facts' do
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/hostgroups_controller_test.rb b/test/functional/hostgroups_controller_test.rb
index 4be39b1..e985936 100644
--- a/test/functional/hostgroups_controller_test.rb
+++ b/test/functional/hostgroups_controller_test.rb
@@ -47,4 +47,21 @@ class HostgroupsControllerTest < ActionController::TestCase
     assert_redirected_to hostgroups_url
     assert !Hostgroup.exists?(hostgroup.id)
   end
+
+  def setup_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  test 'user with viewer rights should fail to edit a hostgroup ' do
+    setup_user
+    get :edit, {:id => Hostgroup.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should succeed in viewing hostgroups' do
+    setup_user
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/hosts_controller_test.rb b/test/functional/hosts_controller_test.rb
index 147406a..1baf516 100644
--- a/test/functional/hosts_controller_test.rb
+++ b/test/functional/hosts_controller_test.rb
@@ -138,35 +138,173 @@ class HostsControllerTest < ActionController::TestCase
     assert_template 'new'
   end
 
-  context "multiple assignments" do
-    setup do
-      @host1 = hosts(:otherfullhost)
-      @host2 = hosts(:anotherfullhost)
+  def setup_user_and_host operation
+    as_admin do
+      @one             = users(:one)
+      @one.domains     = []
+      @one.hostgroups  = []
+      @one.user_facts  = []
+      @host1           = hosts(:one)
+      @host1.owner     = users(:admin)
+      @host1.save!
+      @host2           = hosts(:two)
+      @host2.owner     = users(:admin)
+      @host2.save!
+      @one.roles       = [Role.find_by_name('Anonymous'), Role.find_by_name("#{operation.capitalize} hosts")]
+    end
+    Host.per_page == 1000
+    @request.session[:user] = @one.id
+  end
+
+  test 'user with edit host rights and domain is set should succeed in viewing host1' do
+    setup_user_and_host "Edit"
+    as_admin do
+      @one.domains  = [domains(:mydomain)]
+      @host1.domain = domains(:mydomain)
+      @host2.domain = domains(:yourdomain)            
+    end
+    get :index
+    assert_response :success
+    assert @response.body =~ /#{@host1.shortname}/
+  end
+
+  test 'user with edit host rights and domain is set should fail to view host2' do
+    setup_user_and_host "Edit"
+    as_admin do
+      @one.domains  = [domains(:mydomain)]
+      @host1.domain = domains(:mydomain)
+      @host2.domain = domains(:yourdomain)      
+    end
+    get :index
+    assert_response :success
+    assert @response.body !~ /#{@host2.name}/
+  end
+
+  test 'user with edit host rights and ownership is set should succeed in viewing host1' do
+    setup_user_and_host "Edit"
+    as_admin do
+      @host1.owner = @one
+      @host2.owner = users(:two)
+      @one.filter_on_owner = true
+      @one.save!
+      @host1.save!
+      @host2.save!
+    end
+    get :index
+    assert_response :success
+    assert @response.body =~ /#{@host1.name}/
+  end
+  
+  test 'user with edit host rights and ownership is set should fail to view host2' do
+    setup_user_and_host "Edit"
+    as_admin do
+      @host1.owner = @one
+      @host2.owner = users(:two)
+      @one.filter_on_owner = true
+      @one.save!
+      @host1.save!
+      @host2.save!
+    end
+    get :index
+    assert_response :success
+    assert @response.body !~ /#{@host2.name}/
+  end
+
+  test 'user with edit host rights and hostgroup is set should succeed in viewing host1' do
+    setup_user_and_host "Edit"
+    as_admin do
+      @host1.hostgroup = hostgroups(:common)
+      @host2.hostgroup = hostgroups(:unusual)
+      @one.hostgroups  = [hostgroups(:common)]
+      @host1.save!
+      @host2.save!
+    end
+    get :index
+    assert_response :success
+    assert @response.body =~ /#{@host1.name}/
+  end
+  
+  test 'user with edit host rights and hostgroup is set should fail to view host2' do
+    setup_user_and_host "Edit"
+    as_admin do
+      @host1.hostgroup = hostgroups(:common)
+      @host2.hostgroup = hostgroups(:unusual)
+      @one.hostgroups  = [hostgroups(:common)]
+      @host1.save!
+      @host2.save!
     end
+    get :index
+    assert_response :success
+    assert @response.body !~ /#{@host2.name}/
+  end
 
-    context "with update environments" do
-      should "change environments" do
-        assert @host1.environment == environments(:production)
-        assert @host2.environment == environments(:production)
-        post :update_multiple_environment,
-             {:environment => { :id => environments(:global_puppetmaster).id}},
-             {:selected => [@host1.id, @host2.id], :user => User.first.id}
-        assert Host.find(@host1.id).environment == environments(:global_puppetmaster)
-        assert Host.find(@host2.id).environment == environments(:global_puppetmaster)
-      end
+  test 'user with edit host rights and facts are set should succeed in viewing host1' do
+    setup_user_and_host "Edit"
+    as_admin do
+      fn_id = Puppet::Rails::FactName.find_or_create_by_name("architecture").id
+      FactValue.create! :host => @host1, :fact_name_id => fn_id, :value    => "x86_64"
+      FactValue.create! :host => @host2, :fact_name_id => fn_id, :value    => "i386"
+      UserFact.create!  :user => @one,   :fact_name_id => fn_id, :criteria => "x86_64", :operator => "=", :andor => "or"
     end
-    context "with update parameters" do
-      should "change parameters" do
-        @host1.host_parameters = [HostParameter.create(:name => "p1", :value => "yo")]
-        @host2.host_parameters = [HostParameter.create(:name => "p1", :value => "hi")]
-        post :update_multiple_parameters,
-             {:name => { "p1" => "hello"}},
-             {:selected => [@host1.id, @host2.id], :user => User.first.id}
-        assert Host.find(@host1.id).host_parameters[0][:value] == "hello"
-        assert Host.find(@host2.id).host_parameters[0][:value] == "hello"
-      end
+    get :index
+    assert_response :success
+    assert @response.body =~ /#{@host1.name}/
+  end
+
+  test 'user with edit host rights and facts are set should fail to view host2' do
+    setup_user_and_host "Edit"
+    as_admin do
+      fn_id = Puppet::Rails::FactName.find_or_create_by_name("architecture").id
+      FactValue.create! :host => @host1, :fact_name_id => fn_id, :value    => "x86_64"
+      FactValue.create! :host => @host2, :fact_name_id => fn_id, :value    => "i386"
+      UserFact.create!  :user => @one,   :fact_name_id => fn_id, :criteria => "x86_64", :operator => "=", :andor => "or"
     end
+    get :index
+    assert_response :success
+    assert @response.body !~ /#{@host2.name}/
+  end
+
+  test 'user with view host rights should fail to edit host' do
+    setup_user_and_host "View"
+    get :edit, {:id => @host1.id}
+    assert @response.status == '403 Forbidden'
+  end
+  
+  test 'user with view host rights should should succeed in viewing hosts' do
+    setup_user_and_host "View"
+    get :index
+    assert_response :success
+  end
+
+
+  def setup_multiple_environments
+    setup_user_and_host "edit"
+    as_admin do
+      @host1 = hosts(:otherfullhost)
+      @host2 = hosts(:anotherfullhost)
+    end
+  end
+
+  test "user with edit host rights with update environments should change environments" do
+    setup_multiple_environments
+    assert @host1.environment == environments(:production)
+    assert @host2.environment == environments(:production)
+    post :update_multiple_environment,
+         {:environment => { :id => environments(:global_puppetmaster).id}},
+         {:selected => [@host1.id, @host2.id], :user => User.first.id}
+    assert Host.find(@host1.id).environment == environments(:global_puppetmaster)
+    assert Host.find(@host2.id).environment == environments(:global_puppetmaster)
+  end
 
+  test "user with edit host rights with update parameters should change parameters" do
+    setup_multiple_environments
+    @host1.host_parameters = [HostParameter.create(:name => "p1", :value => "yo")]
+    @host2.host_parameters = [HostParameter.create(:name => "p1", :value => "hi")]
+    post :update_multiple_parameters,
+         {:name => { "p1" => "hello"}},
+         {:selected => [@host1.id, @host2.id], :user => User.first.id}
+    assert Host.find(@host1.id).host_parameters[0][:value] == "hello"
+    assert Host.find(@host2.id).host_parameters[0][:value] == "hello"
   end
   test "should get errors" do
     get :errors, {}, set_session_user
@@ -195,6 +333,7 @@ class HostsControllerTest < ActionController::TestCase
 
   private
   def initialize_host
+    User.current = users(:admin)
     @host = Host.create :name => "myfullhost",
       :mac => "aabbecddeeff",
       :ip => "123.05.02.03",
